%define pkg tuareg
%define pkgname Tuareg-mode

# If the emacs-el package has installed a pkgconfig file, use that to
# determine install locations and Emacs version at build time,
# otherwise set defaults.
%if %($(pkg-config emacs) ; echo $?)
%define emacs_version 22.1
%define emacs_lispdir %{_datadir}/emacs/site-lisp
%define emacs_startdir %{_datadir}/emacs/site-lisp/site-start.d
%else
%define emacs_version %(pkg-config emacs --modversion)
%define emacs_lispdir %(pkg-config emacs --variable sitepkglispdir)
%define emacs_startdir %(pkg-config emacs --variable sitestartdir)
%endif

# If the xemacs-devel package has installed a pkgconfig file, use that
# to determine install locations and Emacs version at build time,
# otherwise set defaults.
%if %($(pkg-config xemacs) ; echo $?)
%define xemacs_version 21.5
%define xemacs_lispdir %{_datadir}/xemacs/site-lisp
%define xemacs_startdir %{_datadir}/xemacs/site-lisp/site-start.d
%else
%define xemacs_version %(pkg-config xemacs --modversion)
%define xemacs_lispdir %(pkg-config xemacs --variable sitepkglispdir)
%define xemacs_startdir %(pkg-config xemacs --variable sitestartdir)
%endif


Name:           emacs-common-%{pkg}
Version:        1.45.6
Release:        1%{?dist}
Summary:        Emacs mode for editing ocaml
#Summary:        Emacs and XEmacs mode for editing ocaml

Group:          Development/Libraries
License:        GPLv2+
URL:            http://www-rocq.inria.fr/~acohen/tuareg/index.html.en
Source0:        http://www-rocq.inria.fr/~acohen/tuareg/mode/tuareg-mode-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch
BuildRequires:  emacs emacs-el
BuildRequires:  xemacs xemacs-devel


%description
%{pkgname} is an add-on package for GNU Emacs for editing OCaml source
files.  It is much better than the default mode included in Emacs or
the one provided by INRIA.

This package contains the common files.  Install emacs-%{pkg} to get
the complete package.


%package -n emacs-%{pkg}
Summary:        Compiled elisp files to run %{pkgname} under GNU Emacs
Group:          Development/Libraries
Requires:       emacs(bin) >= %{emacs_version}
Requires:       emacs-common-%{pkg} = %{version}-%{release}

%description -n emacs-%{pkg}
This package contains the byte compiled elisp packages to run
%{pkgname} with GNU Emacs.


%package -n emacs-%{pkg}-el
Summary:        Elisp source files for %{pkgname} under GNU Emacs
Group:          Development/Libraries
Requires:       emacs-%{pkg} = %{version}-%{release}

%description -n emacs-%{pkg}-el
This package contains the elisp source files for %{pkgname} under GNU
Emacs. You do not need to install this package to run
%{pkgname}. Install the emacs-%{pkg} package to use %{pkgname} with
GNU Emacs.


# NB. 'xemacs' support appears to be broken upstream:
#
# While compiling toplevel forms in file /tmp/tuareg-mode-1.45.6/sym-lock.el:
# !! File error (("Cannot open load file" "atomic-extents"))
# >>Error occurred processing sym-lock.el: Cannot open load file: "atomic-extents"
#
# I have only limited understanding of xemacs environment, so
# for now xemacs is disabled.

#%package -n xemacs-%{pkg}
#Summary:        Compiled elisp files to run %{pkgname} under XEmacs
#Group:          Development/Libraries
#Requires:       xemacs(bin) >= %{xemacs_version}
#Requires:       emacs-common-%{pkg} = %{version}-%{release}
#
#%description -n xemacs-%{pkg}
#This package contains the byte compiled elisp packages to use
#%{pkgname} with XEmacs.
#
#
#%package -n xemacs-%{pkg}-el
#Summary:        Elisp source files for %{pkgname} under XEmacs
#Group:          Development/Libraries
#Requires:       xemacs-%{pkg} = %{version}-%{release}
#
#%description -n xemacs-%{pkg}-el
#This package contains the elisp source files for %{pkgname} under
#XEmacs. You do not need to install this package to run
#%{pkgname}. Install the xemacs-%{pkg} package to use %{pkgname} with
#XEmacs.


%prep
%setup -q -n %{pkg}-mode-%{version}
for f in HISTORY README LISEZMOI; do
  mv $f $f.old; iconv -f iso-8859-1 -t utf-8 < $f.old > $f
done

%build
# 'append-tuareg.el' and 'custom-tuareg.el' are example config
# files, so they will end up in the documentation directory.
# 'sym-lock.el' is only used by XEmacs.
emacs --no-site-file -q -batch -L . -f batch-byte-compile \
  tuareg.el camldebug.el


%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/%{emacs_lispdir}/%{pkg}
#mkdir -p $RPM_BUILD_ROOT/%{emacs_startdir}
install -m 0644 tuareg.el camldebug.el tuareg.elc camldebug.elc \
  $RPM_BUILD_ROOT/%{emacs_lispdir}/%{pkg}/

#mkdir -p $RPM_BUILD_ROOT/%{xemacs_lispdir}/%{pkg}
##mkdir -p $RPM_BUILD_ROOT/%{xemacs_startdir}
#install -m 0644 tuareg.el camldebug.el tuareg.elc camldebug.elc \
#  $RPM_BUILD_ROOT/%{xemacs_lispdir}/%{pkg}/


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc COPYING HISTORY LISEZMOI README append-tuareg.el custom-tuareg.el


%files -n emacs-%{pkg}
%defattr(-,root,root,-)
%doc COPYING
%{emacs_lispdir}/%{pkg}/*.elc
#%{emacs_startdir}/*.el
%dir %{emacs_lispdir}/%{pkg}


%files -n emacs-%{pkg}-el
%defattr(-,root,root,-)
%doc COPYING
%{emacs_lispdir}/%{pkg}/*.el


#%files -n xemacs-%{pkg}
#%defattr(-,root,root,-)
#%doc COPYING
#%{xemacs_lispdir}/%{pkg}/*.elc
##%{xemacs_startdir}/*.el
#%dir %{xemacs_lispdir}/%{pkg}
#
#
#%files -n xemacs-%{pkg}-el
#%defattr(-,root,root,-)
#%doc COPYING
#%{xemacs_lispdir}/%{pkg}/*.el


%changelog
* Tue Feb 19 2008 Richard W.M. Jones <rjones@redhat.com> - 1.45.6-1
- Initial RPM release.
